// DialogFilterEdit.cpp : implementation file
//

#include "stdafx.h"
#include "LogAnalysis.h"
#include "DialogFilterEdit.h"


// CDialogFilterEdit dialog

IMPLEMENT_DYNAMIC(CDialogFilterEdit, CDialog)

CDialogFilterEdit::CDialogFilterEdit(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogFilterEdit::IDD, pParent)
{
}

CDialogFilterEdit::~CDialogFilterEdit()
{
}

void CDialogFilterEdit::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_INCLUDE, lstInclude);
	DDX_Control(pDX, IDC_LIST_EXCLUDE, lstExclude);
}


BEGIN_MESSAGE_MAP(CDialogFilterEdit, CDialog)
	ON_WM_SIZE()
	ON_WM_CONTEXTMENU()
END_MESSAGE_MAP()


// CDialogFilterEdit message handlers

BOOL CDialogFilterEdit::OnInitDialog()
{
	CDialog::OnInitDialog();

	lstInclude.InsertColumn(0,"",LVCFMT_LEFT,435);
	lstInclude.SetExtendedStyle(LVS_EX_GRIDLINES);
	lstExclude.InsertColumn(0,"",LVCFMT_LEFT,435);
	lstExclude.SetExtendedStyle(LVS_EX_GRIDLINES);
	Load(lstInclude,pInclude);
	Load(lstExclude,pExclude);

	//set icon
	HICON hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	SetIcon(hIcon, TRUE);
	SetIcon(hIcon, FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CDialogFilterEdit::OnOK()
{
	Save(lstInclude,pInclude);
	Save(lstExclude,pExclude);

	CDialog::OnOK();
}

void CDialogFilterEdit::Load(CEditableListCtrl& lst, CStringList* pItems)
{
	POSITION pos = pItems->GetHeadPosition();
	int i = 0;
	while(pos!=NULL){
		i++;
		lst.InsertItem(i,pItems->GetNext(pos));
	}
}

void CDialogFilterEdit::Save(CEditableListCtrl& lst, CStringList* pItems)
{
	int nCount = lst.GetItemCount();
	pItems->RemoveAll();
	for (int x = 0; x < nCount; x++)
	{
		pItems->AddTail(lst.GetItemText(x,0));
	}
}

void CDialogFilterEdit::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	if(m_hWnd!=NULL){

		CRect dlgrect;
		GetClientRect(dlgrect);
		ScreenToClient(dlgrect);
		LONG dlg_width = dlgrect.right - dlgrect.left;
		LONG dlg_height = dlgrect.bottom - dlgrect.top;

		if(lstInclude.m_hWnd!=NULL){
			CRect rect;
			lstInclude.GetWindowRect(&rect);
			ScreenToClient(rect);
			lstInclude.MoveWindow(rect.left, rect.top, dlg_width - (2*rect.left), dlg_height/2 - (2*rect.top));

			lstExclude.GetWindowRect(&rect);
			ScreenToClient(rect);
			lstExclude.MoveWindow(rect.left, dlg_height/2, dlg_width - (2*rect.left), dlg_height/2 - 46);

			CWnd* w = GetDlgItem(IDC_STATIC_EXCLUDE);
			if(w!=NULL){
				w->GetWindowRect(&rect);
				ScreenToClient(rect);
				w->MoveWindow(rect.left,dlg_height/2 - rect.Height() - 5,rect.Width(),rect.Height());
			}

			w = GetDlgItem(IDOK);
			if(w!=NULL){
				w->GetWindowRect(&rect);
				ScreenToClient(rect);
				w->MoveWindow(dlg_width - (2*rect.Width()) - 16, dlg_height - rect.Height() - 12, rect.Width(), rect.Height());
			}

			w = GetDlgItem(IDCANCEL);
			if(w!=NULL){
				w->GetWindowRect(&rect);
				ScreenToClient(rect);
				w->MoveWindow(dlg_width - rect.Width() - 10, dlg_height - rect.Height() - 12, rect.Width(), rect.Height());
			}
		}
	}
}

void CDialogFilterEdit::OnContextMenu(CWnd* pWnd, CPoint point)
{
	CEditableListCtrl* editlist = NULL;
	if(pWnd->m_hWnd==this->lstInclude.m_hWnd)
		editlist = &this->lstInclude;

	if(pWnd->m_hWnd==this->lstExclude.m_hWnd)
		editlist = &this->lstExclude;

	if(editlist!=NULL){
		CMenu menu;
		DWORD dwSelected;
		menu.LoadMenu(IDR_MENU_EDITLIST);
		CMenu *pmenu = menu.GetSubMenu(0);
		dwSelected = pmenu->TrackPopupMenu(TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_NONOTIFY|TPM_RETURNCMD,point.x,point.y,this,NULL);
		menu.DestroyMenu();
		CString s;
		if(dwSelected>0){
			switch(dwSelected){
			case ID_EDIT_LIST_INSERT:
				s.LoadString(IDS_APP_FILTER_NEWITEM);
				editlist->NewItem(s);
				break;
			case ID_EDIT_LIST_EDIT:
				editlist->EditCurrent();
				break;
			case ID_EDIT_LIST_DELETE:
				editlist->DeleteSelectedItems();
				break;
			default:
				s.LoadString(IDS_APP_UNKNOWNCOMMAND);
				AfxMessageBox(s);
			}
		}
	}
}
