// DialogWhois.cpp : implementation file
//

#include "stdafx.h"
#include "LogAnalysis.h"
#include "DialogWhois.h"
#include "Whois.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDialogWhois dialog

CDialogWhois::CDialogWhois(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogWhois::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialogWhois)
	m_IP = _T("");
	m_DefaultServer = _T("whois.arin.net");
	m_WhoisServer = m_DefaultServer;
	//}}AFX_DATA_INIT
}


void CDialogWhois::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogWhois)
	DDX_Control(pDX, IDC_IP, m_IPCtrl);
	DDX_Control(pDX, IDC_WHOISINFO, m_WhoisInfo);
	DDX_Text(pDX, IDC_IP, m_IP);
	DDX_CBString(pDX, IDC_CBOSERVER, m_WhoisServer);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogWhois, CDialog)
	//{{AFX_MSG_MAP(CDialogWhois)
	ON_BN_CLICKED(IDC_LOOKUP, OnLookup)
	//}}AFX_MSG_MAP
	ON_WM_SIZE()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDialogWhois message handlers

void CDialogWhois::OnLookup() 
{
	UpdateData(TRUE);

	if(m_WhoisServer.GetLength()>0){
		m_DefaultServer = m_WhoisServer;
		if(m_IP.GetLength()>0){
			CString text;
			text = WhoisLookup(m_WhoisServer,m_IP);
			CStringHelper::MakeWinEOL(text);
			m_WhoisInfo.SetWindowText(text);
		}else{
			CString s;
			s.LoadString(IDS_APP_ENTERIPADDRESS);
			AfxMessageBox(s);
			m_IPCtrl.SetFocus();
		}
	}else{
		CString s;
		s.LoadString(IDS_APP_ENTERWHOISSERVER);
		AfxMessageBox(s);
	}
}

CString CDialogWhois::WhoisLookup(CString& Server, CString &IP)
{
	CWhois whois;
	return whois.Lookup(Server,IP);
}

void CDialogWhois::SetServer(LPCTSTR Server)
{
	m_DefaultServer = Server;
	m_WhoisServer = Server;
}

CString CDialogWhois::GetServer()
{
	return m_DefaultServer;
}

void CDialogWhois::SetQuery(LPCTSTR Query)
{
	m_IP = Query;
}

void CDialogWhois::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	if(m_hWnd!=NULL){

		CRect dlgrect;
		GetClientRect(dlgrect);
		ScreenToClient(dlgrect);
		LONG dlg_width = dlgrect.right - dlgrect.left;
		LONG dlg_height = dlgrect.bottom - dlgrect.top;

		CRect rect;

		CWnd* w = GetDlgItem(IDC_WHOISINFO);
		if(w!=NULL){
			w->GetWindowRect(&rect);
			ScreenToClient(rect);
			w->MoveWindow(rect.left,rect.top,dlg_width - 2,dlg_height - 60);

			LONG totalbuttons = 0;

			w = GetDlgItem(IDC_LOOKUP);
			if(w!=NULL){
				w->GetWindowRect(&rect);
				ScreenToClient(rect);
				w->MoveWindow(dlg_width - (2*rect.Width()) - 8, rect.top, rect.Width(), rect.Height());
				totalbuttons += rect.Width();
			}

			w = GetDlgItem(IDCANCEL);
			if(w!=NULL){
				w->GetWindowRect(&rect);
				ScreenToClient(rect);
				w->MoveWindow(dlg_width - rect.Width() - 2, rect.top, rect.Width(), rect.Height());
				totalbuttons += rect.Width();
			}

			w = GetDlgItem(IDC_CBOSERVER);
			if(w!=NULL){
				w->GetWindowRect(&rect);
				ScreenToClient(rect);
				w->MoveWindow(rect.left, rect.top, dlg_width - rect.left - totalbuttons - 16, rect.Height());
			}

			w = GetDlgItem(IDC_IP);
			if(w!=NULL){
				w->GetWindowRect(&rect);
				ScreenToClient(rect);
				w->MoveWindow(rect.left, rect.top, dlg_width - rect.left - totalbuttons - 16, rect.Height());
			}	
		}
	}
}
