/*
	AQTRONIX XML Configuration Editor
	Copyright 2011-2015 Parcifal Aertssen

	This file is part of AQTRONIX XML Configuration Editor.

    AQTRONIX XML Configuration Editor is free software; you can redistribute
	it and/or modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of the
	License, or (at your option) any later version.

    AQTRONIX XML Configuration Editor is distributed in the hope that it will
	be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX XML Configuration Editor; if not, write to the 
	Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#include "stdafx.h"
#include "SortableListCtrl.h"

CSortableListCtrl::CSortableListCtrl(void)
{
}

CSortableListCtrl::~CSortableListCtrl(void)
{
}

BEGIN_MESSAGE_MAP(CSortableListCtrl, CListCtrl)
	//{{AFX_MSG_MAP(CSortableListCtrl)
	//ON_NOTIFY(HDN_ITEMCLICK, 0, OnItemclickListSort) //not working?
	ON_NOTIFY(HDN_ITEMCLICKA, 0, OnItemclickListSort)
	ON_NOTIFY(HDN_ITEMCLICKW, 0, OnItemclickListSort) //this one works
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/* 
 * SORT
 * http://support.microsoft.com/kb/250614
 * http://msdn.microsoft.com/en-us/library/bb387110.aspx
 * http://www.codeproject.com/KB/list/clistctrl_sort.aspx
 */

struct PARAMSORT{
        PARAMSORT(CListCtrl* pList, int columnIndex, bool ascending)
            :m_pList(pList)
            ,m_ColumnIndex(columnIndex)
            ,m_Ascending(ascending)
        {}

        CListCtrl* m_pList;
        int  m_ColumnIndex;
        bool m_Ascending;
    };

void CSortableListCtrl::OnItemclickListSort(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NMLISTVIEW *pLV = (NMLISTVIEW *) pNMHDR;
	bool sortasc(true);

	//remember sort if ascending, next time descending
	if(pLV->iItem==SortedColumn){
		sortasc=false;
		SortedColumn = -1;
	}else{
		SortedColumn = pLV->iItem;
	}

	//sort
	SortColumn(pLV->iItem,sortasc);

	*pResult = 0;
}

void CSortableListCtrl::SortColumn(int ColumnIndex, bool Ascending)
{
    PARAMSORT par(this, ColumnIndex, Ascending);
	#if _MSC_VER > 1200
		SortItemsEx((PFNLVCOMPARE)SortFuncEx, (LPARAM)&par);
	#else
		//SortItems((PFNLVCOMPARE)SortFunc, (LPARAM)&par);
	#endif
}

int CALLBACK CSortableListCtrl::SortFuncEx(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	PARAMSORT&		  ps = *(PARAMSORT*)lParamSort;
    CListCtrl* pListCtrl = (CListCtrl*) ps.m_pList;
    CString		strItem1 = pListCtrl->GetItemText(static_cast<int>(lParam1), ps.m_ColumnIndex);
    CString		strItem2 = pListCtrl->GetItemText(static_cast<int>(lParam2), ps.m_ColumnIndex);

	if(ps.m_Ascending){
		return _tcscmp(strItem1,strItem2);
	}else{
		return _tcscmp(strItem2,strItem1);
	}
}

int CALLBACK CSortableListCtrl::SortFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	//TODO: SORT - not working because LPARAM is not set in InsertItem/SetItem
	return 0;
}

void CSortableListCtrl::MoveDown()
{
	int item = this->GetSelectionMark();
	if(item>-1){
		item++;
		MoveTo(item);
	}else{
		MoveTo(0);
	}
}

void CSortableListCtrl::MoveUp()
{
	int item = this->GetSelectionMark();
	if(item>0){
		item--;
		MoveTo(item);
	}
}

void CSortableListCtrl::MoveTo(int item)
{
	this->SetItemState(item,LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED|LVIS_FOCUSED);
	this->SetSelectionMark(item);
	this->EnsureVisible(item,FALSE);
}
