#pragma once

#include "Settings.h"

//TODO: FILTERS - regex
//#define REGEX
#ifdef REGEX
#include "RegexCache.h"
#endif

#define MAX_INI_FILE_SIZE 128000

class CLogAnalysisSettings : public CSettings
{
protected:
	bool ReadFromFileINI(LPCTSTR fn);
	bool WriteToFileINI(LPCTSTR fn);
	bool WriteToFileXML(LPCTSTR fn);

public:
	void LoadDefaults();
	bool ParseXML(CString& key, CString& val);
	CString ToXML();

	virtual bool IsAllowedByFilters(CString& Line);

	//general
	class GeneralParameters{
	public:
		int SortedColumn;
		CString EOL;
		CString Separator;
		bool Trim;
		bool FirstLineHeader;
		CString WhoisServer;
		bool WordWrap;
	}General;

	//filters
	class FilterParameters{
	public:
		int MaxEntries;
		CStringList Include;
		CStringList Exclude;
		CStringList Regex;
	}Filter;

	//extract field
	class ExtractFieldParameters{
	public:
		bool Enabled;
		CString Name;
	}ExtractField; //TODO: Extract field - in settings

	//lookup IP
	class IPLookupParameters{
	public:
		bool DNS;
		bool Country;
		int ColumnIndex;
	}IPLookup;

#ifdef REGEX
	CRegexCache regex_cache;
#endif

	CLogAnalysisSettings(void);
	virtual ~CLogAnalysisSettings(void);
};
