/*
    AQTRONIX C++ Library
    Copyright 2016 Parcifal Aertssen

    This file is part of AQTRONIX C++ Library.

    AQTRONIX C++ Library is free software; you can redistribute it
	and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.

    AQTRONIX C++ Library is distributed in the hope that it will be
	useful, but WITHOUT ANY WARRANTY; without even the implied warranty
    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX C++ Library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
    MA  02111-1307  USA
*/
#pragma once

#include "LogAnalysisSettings.h"

#define METALINE		_T("#")
#define HEADERFIELD		_T("#Fields: ")
#define HEADERSOFTWARE	_T("#Software: ")
#define HEADERDATE		_T("#Date: ")

class CLogReader
{
public:
	CString HeaderDate;
	CString HeaderName;

protected:
	//file
	CString filename;
	ULONGLONG CurrentPosition;

	//columns
	CStringArray FieldList;

public:
	//settings
	CLogAnalysisSettings Settings;

	//file
	bool IsReading;
	bool AbortReading;
	int ColumnCount;

	bool ReadLog(LPCTSTR fn, LONGLONG Start=0);
	bool ReadLogAppend();
	bool HasFile();
	static CString DetectFieldSeparator(CString& Line);

	//columns
	virtual void SetSingleColumn() = 0;
	virtual void SetColumns(CStringList& Fields, bool UseFieldNameAsColumnHeading) = 0;
	virtual void SetColumns(CString& Fields, bool UseFieldNameAsColumnHeading);
	virtual void SetHeaders(CString& Header);

	//rows
	virtual bool AddLine(CString& Line) = 0;
	virtual void AddLines(CStringList& lines);
	CString& TrimField(CString& field);

	CLogReader(void);
	virtual ~CLogReader(void);
};
