#pragma once
#include "afxwin.h"

class CLogViewDetails : public CView
{
protected:
	DECLARE_DYNCREATE(CLogViewDetails)
	CRichEditCtrl details;
public:
	//text
	void SetDetailView(CStringList& Fields, int ColumnCount);
	void SetDetailView(LPCTSTR Text, LPCTSTR Separator, int ColumnCount);
	inline void AppendDetailView(LPCTSTR Text);
	void Clear();
	CString GetSelText();
	CFont font;

	BOOL CanUndo();
	void Undo();
	BOOL CanRedo();
	void Redo();
	void Cut();
	void Copy();
	void Paste();
	BOOL WordWrapping(bool enabled);

	void PrintDetails();
	void PrintPreview();

public:
	CLogViewDetails(void);
	~CLogViewDetails(void);

// Overrides
public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
public:
	DECLARE_MESSAGE_MAP()

	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
};
