#pragma once
#include "afxwin.h"

#include "resource.h"       // main symbols
#include "LogViewDetails.h"
#include "SortableListCtrl.h"
#include "LogReader.h"

class CLogViewList : public CView, public CLogReader
{
protected:
	DECLARE_DYNCREATE(CLogViewList)

public:
	//listcontrol
	CSortableListCtrl loglist;
	CLogViewDetails* pDetails;
protected:
	//filters
	void BindDetailToList();
	int filtered_count;

public:
	bool OpenLog(LPCTSTR fn);
	void RefreshLog();
	void CloseLog();
	void PrintLog();
	void PrintPreview();
	bool Export(LPCTSTR FileName);

	//columns
	void SortColumn(int ColumnIndex, bool Ascending);
	virtual void SetSingleColumn();
	virtual void SetColumns(CStringList& Fields, bool UseFieldNameAsColumnHeading);
	int CalculateColumnWidth(CString& Fld, int MinimumLength, int MaximumLength);

	//rows
	virtual bool AddLine(CString& Line);
	void Clear();
	CString GetCurrentEntry();
	int EntryCount() const;
	int FilteredCount() const;
	CFont font;
	void SetEntryProgress(int number);
	CString ExtractField(CString& Line, CString MatchStart, CString MatchEnd);

	//filters
	virtual void AddFilter(CString& Text, int FilterType);
	virtual void ClearFilters();

	CLogViewList(void);
	~CLogViewList(void);

	// Overrides
public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
public:
	DECLARE_MESSAGE_MAP()
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
};
