// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__D18C0956_75ED_4F78_88A4_C1495491986C__INCLUDED_)
#define AFX_MAINFRM_H__D18C0956_75ED_4F78_88A4_C1495491986C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "LogViewList.h"
#include "LogViewDetails.h"

class CMainFrame : public CFrameWnd
{
	
public:
	CMainFrame();
	virtual ~CMainFrame();
protected: 
	DECLARE_DYNAMIC(CMainFrame)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	//}}AFX_VIRTUAL

// Variables
protected:
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	CSplitterWnd    m_wndSplitter;
	CLogViewList* pList;
	CLogViewDetails* pDetails;

// Implementation
public:
	void WhoisLookup(CString& Query);
	void DNSLookup(CString& Query);
	void AddFilter(LPCTSTR Text);
	void SetSeparator();
protected:
	bool SetClipboardText(CString& Text);
	void SetMenuItemCheck(int submenu, UINT ID, bool checked);
	void SyncMenu();
	bool AbortOpenFile;

	class _DeferredFile{
	public:
		CString Name;
		CString Title;

		void Reset(){
			Name = _T("");
			Title = _T("");
		}

		bool IsEmpty() { 
			return Name.GetLength()==0; 
		}
	} DeferredFile;

public:
	bool OpenFile(LPCTSTR fn);
	void Clear();

	void DoEvents();
	void SetProgress(LPCTSTR message);
	void SetProgress(long l);
	void SetStatusBarCount();
	void SetStatusBar(LPCTSTR Text);
	void SetWindowTitle(LPCTSTR Caption);
	void LoadDefaultFile();
	void LoadDeferredFile();
	BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	virtual BOOL PreTranslateMessage(MSG* pMsg);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif


// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSetFocus(CWnd *pOldWnd);
	afx_msg void OnFileOpen();
	afx_msg void OnFileClose();
	afx_msg void OnFilePrintPreview();
	afx_msg void OnFilePrint();
	afx_msg void OnEditUndo();
	afx_msg void OnEditRedo();
	afx_msg void OnEditCut();
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	afx_msg void OnUpdateNotReading(CCmdUI *pCmdUI);
	afx_msg void OnUpdateCanUndo(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCanRedo(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNeedSelection(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNeedClip(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNeedFile(CCmdUI* pCmdUI);
	afx_msg void OnWhoisLookup();
	afx_msg void OnDNSLookup();
	afx_msg void OnListDown();
	afx_msg void OnListUp();
	afx_msg void OnSaveSettings();
	afx_msg void OnExportView();
	afx_msg void OnSetSeparator();
	afx_msg void OnSetTrim();
	afx_msg void OnSetFirstLineHeader();
	afx_msg void OnSetWordWrap();
	afx_msg void OnFilterAdd();
	afx_msg void OnFilterEdit();
	afx_msg void OnFilterMaxEntries();
	afx_msg void OnFilterClear();
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnTimer(UINT_PTR nIDEvent);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__D18C0956_75ED_4F78_88A4_C1495491986C__INCLUDED_)
